Index: /trunk/source/visualization/gMocren/src/G4GMocrenFileSceneHandler.cc
===================================================================
--- /trunk/source/visualization/gMocren/src/G4GMocrenFileSceneHandler.cc	(revision 1273)
+++ /trunk/source/visualization/gMocren/src/G4GMocrenFileSceneHandler.cc	(revision 1274)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4GMocrenFileSceneHandler.cc,v 1.12 2009/12/03 11:44:42 akimura Exp $
+// $Id: G4GMocrenFileSceneHandler.cc,v 1.14 2010/05/11 10:44:11 allison Exp $
 // GEANT4 tag $Name:  $
 //
@@ -93,7 +93,7 @@
 
 //-- for a debugging
-const bool GFDEBUG = false;
-const bool GFDEBUG_TRK = false;//true;
-const bool GFDEBUG_HIT = false;//true;
+const G4bool GFDEBUG = false;
+const G4bool GFDEBUG_TRK = false;//true;
+const G4bool GFDEBUG_HIT = false;//true;
 const G4int GFDEBUG_DET = 0; // 0: false 
 
@@ -170,5 +170,5 @@
   kbSetModalityVoxelSize = false;
 
-  for(int i = 0; i < 3; i++) {
+  for(G4int i = 0; i < 3; i++) {
     kModalitySize[i] = 0;
     kNestedVolumeDimension[i] = 0;
@@ -182,5 +182,5 @@
 {
   // g4_00.gdd, g4_01.gdd, ..., g4_MAX_FILE_INDEX.gdd
-  const int MAX_FILE_INDEX = kMaxFileNum - 1 ;
+  const G4int MAX_FILE_INDEX = kMaxFileNum - 1 ;
 
   // dest directory (null if no environmental variables is set)
@@ -191,6 +191,6 @@
 
   // Automatic updation of file names
-  static int currentNumber = 0;
-  for( int i = currentNumber ; i < kMaxFileNum ; i++) { 
+  static G4int currentNumber = 0;
+  for( G4int i = currentNumber ; i < kMaxFileNum ; i++) { 
 
     // Message in the final execution
@@ -268,7 +268,7 @@
     minmax[1] = ctdens.GetMaxCT();
     kgMocrenIO->setModalityImageMinMax(minmax);
-    std::vector<float> map;
-    float dens;
-    for(int i = minmax[0]; i <= minmax[1]; i++) {
+    std::vector<G4float> map;
+    G4float dens;
+    for(G4int i = minmax[0]; i <= minmax[1]; i++) {
       dens = ctdens.GetDensity(i);
       map.push_back(dens);
@@ -283,7 +283,7 @@
       ifile >> minmax[0] >> minmax[1];
       kgMocrenIO->setModalityImageMinMax(minmax);
-      std::vector<float> map;
-      float dens;
-      for(int i = minmax[0]; i <= minmax[1]; i++) {
+      std::vector<G4float> map;
+      G4float dens;
+      for(G4int i = minmax[0]; i <= minmax[1]; i++) {
 	ifile >> dens;
 	map.push_back(dens);
@@ -329,5 +329,5 @@
     kFlagSaving_g4_gdd = false; 
 
-    std::map<Index3D, float>::iterator itr = kNestedModality.begin();
+    std::map<Index3D, G4float>::iterator itr = kNestedModality.begin();
     G4int xmax=0, ymax=0, zmax=0;
     for(; itr != kNestedModality.end(); itr++) {
@@ -347,10 +347,10 @@
 
     G4int nxy = kModalitySize[0]*kModalitySize[1];
-    //std::map<G4int, float>::iterator itr;
-    for(int z = 0; z < kModalitySize[2]; z++) {
+    //std::map<G4int, G4float>::iterator itr;
+    for(G4int z = 0; z < kModalitySize[2]; z++) {
       short * modality = new short[nxy];
-      for(int y = 0; y < kModalitySize[1]; y++) {
-	for(int x = 0; x < kModalitySize[0]; x++) {
-	  //for(int x = kModalitySize[0]-1; x >= 0 ; x--) {
+      for(G4int y = 0; y < kModalitySize[1]; y++) {
+	for(G4int x = 0; x < kModalitySize[0]; x++) {
+	  //for(G4int x = kModalitySize[0]-1; x >= 0 ; x--) {
 	  //G4int ixy = x + (kModalitySize[1]-y-1)*kModalitySize[0];
 
@@ -377,5 +377,5 @@
     std::map<G4String, std::map<Index3D, G4double> >::iterator hitsListItr = kNestedHitsList.begin();
 
-    for(int n = 0; hitsListItr != kNestedHitsList.end(); hitsListItr++, n++) {
+    for(G4int n = 0; hitsListItr != kNestedHitsList.end(); hitsListItr++, n++) {
 
       kgMocrenIO->newDoseDist();
@@ -384,8 +384,8 @@
 
       G4double minmax[2] = {DBL_MAX, -DBL_MAX};
-      for(int z = 0 ; z < kModalitySize[2]; z++) {
+      for(G4int z = 0 ; z < kModalitySize[2]; z++) {
 	G4double * values = new G4double[nxy];
-	for(int y = 0; y < kModalitySize[1]; y++) {
-	  for(int x = 0; x < kModalitySize[0]; x++) {
+	for(G4int y = 0; y < kModalitySize[1]; y++) {
+	  for(G4int x = 0; x < kModalitySize[0]; x++) {
 
 	    G4int ixy = x + y*kModalitySize[0];
@@ -421,7 +421,7 @@
       rot = kVolumeTrans3D.getRotation().inverse();
       // x
-      std::vector<float *> tracks;
+      std::vector<G4float *> tracks;
       unsigned char colors[3];
-      float * trk = new float[6];
+      G4float * trk = new G4float[6];
       tracks.push_back(trk);
 
@@ -435,14 +435,14 @@
       za -= trans;
       za.transform(rot);
-      for(int i = 0; i < 3; i++) trk[i] = orig[i];
-      for(int i = 0; i < 3; i++) trk[i+3] = xa[i];
+      for(G4int i = 0; i < 3; i++) trk[i] = orig[i];
+      for(G4int i = 0; i < 3; i++) trk[i+3] = xa[i];
       colors[0] = 255; colors[1] = 0; colors[2] = 0;
       kgMocrenIO->addTrack(tracks, colors);
       // y
-      for(int i = 0; i < 3; i++) trk[i+3] = ya[i];
+      for(G4int i = 0; i < 3; i++) trk[i+3] = ya[i];
       colors[0] = 0; colors[1] = 255; colors[2] = 0;
       kgMocrenIO->addTrack(tracks, colors);
       // z
-      for(int i = 0; i < 3; i++) trk[i+3] = za[i];
+      for(G4int i = 0; i < 3; i++) trk[i+3] = za[i];
       colors[0] = 0; colors[1] = 0; colors[2] = 255;
       kgMocrenIO->addTrack(tracks, colors);
@@ -454,6 +454,6 @@
 
     if(GFDEBUG_DET) G4cout << ">>>>>>>>>>>>>>>>>>>>>>   (";
-    std::vector<float> transformObjects;
-    for(int i = 0; i < 3; i++) {
+    std::vector<G4float> transformObjects;
+    for(G4int i = 0; i < 3; i++) {
       // need to check!!
       transformObjects.push_back((kVolumeSize[i]/2. - kVoxelDimension[i]/2.));
@@ -533,5 +533,5 @@
 
     if(GFDEBUG_TRK) G4cout << "   trajectory points : " << G4endl;
-    std::vector<float *> trajectory;
+    std::vector<G4float *> trajectory;
     if(polyline.size() < 2) return;
     G4Polyline::const_iterator preitr = polyline.begin();
@@ -544,5 +544,5 @@
       postPts -= trans;
       postPts.transform(rot);
-      float * stepPts = new float[6];
+      G4float * stepPts = new G4float[6];
       stepPts[0] = prePts.x();
       stepPts[1] = prePts.y();
@@ -657,5 +657,5 @@
 
   //---------- (3) Facet block
-  for (int f = polyhedron.GetNoFacets(); f; f--){
+  for (G4int f = polyhedron.GetNoFacets(); f; f--){
     G4int notLastEdge;
     G4int index = -1; // initialization
@@ -764,9 +764,9 @@
     G4Polyhedron * poly = box.CreatePolyhedron();
     poly->Transform(*fpObjectTransformation);
-    //int nv = poly->GetNoVertices();
+    //G4int nv = poly->GetNoVertices();
     G4Point3D v1, v2;
     G4int next;
     //while(1) { // next flag isn't functional.
-    for(int i = 0; i < 12; i++) { // # of edges is 12.
+    for(G4int i = 0; i < 12; i++) { // # of edges is 12.
       poly->GetNextEdge(v1, v2, next);
       if(next == 0) break;
@@ -927,5 +927,5 @@
       }
       
-      for(int i = 0; i < 3; i++) {
+      for(G4int i = 0; i < 3; i++) {
 	kNestedVolumeDimension[i] = nDaughters[i];
 	//kNestedVolumeDimension[i] = nDaughters[dirAxis[i]];
@@ -940,7 +940,7 @@
       if(nestPara) {
 	G4double prexyz[3] = {0.,0.,0.}, xyz[3] = {0.,0.,0.};
-	for(int n0 = 0; n0 < nDaughters[0]; n0++) {
-	  for(int n1 = 0; n1 < nDaughters[1]; n1++) {
-	    for(int n2 = 0; n2 < nDaughters[2]; n2++) {
+	for(G4int n0 = 0; n0 < nDaughters[0]; n0++) {
+	  for(G4int n1 = 0; n1 < nDaughters[1]; n1++) {
+	    for(G4int n2 = 0; n2 < nDaughters[2]; n2++) {
 		  
 	      G4GMocrenTouchable * touch = new G4GMocrenTouchable(n1, n0);
@@ -961,5 +961,5 @@
 	      xyz[2] = tbox.GetZHalfLength()/mm;
 	      if(n0 != 0 || n1 != 0 || n2 != 0) {
-		for(int i = 0; i < 3; i++) {
+		for(G4int i = 0; i < 3; i++) {
 		  if(xyz[i] != prexyz[i]) G4Exception("Error[gMocrenFileSceneHandler]: Unsupported parameterisation.");
 		}
@@ -980,5 +980,5 @@
 		       << "  density: " << dens << G4endl;
 
-	      for(int i = 0; i < 3; i++) prexyz[i] = xyz[i];
+	      for(G4int i = 0; i < 3; i++) prexyz[i] = xyz[i];
 	    }
 	  }
@@ -990,5 +990,7 @@
 	// mesh size
 	if(!kbSetModalityVoxelSize) {
-	  float spacing[3] = {2*xyz[0], 2*xyz[1], 2*xyz[2]};
+	  G4float spacing[3] = {static_cast<G4float>(2*xyz[0]),
+                                static_cast<G4float>(2*xyz[1]),
+                                static_cast<G4float>(2*xyz[2])};
 	  kgMocrenIO->setVoxelSpacing(spacing);
 	  kVoxelDimension.set(spacing[0], spacing[1], spacing[2]);
@@ -1014,5 +1016,5 @@
 	  G4cout << "     physical volume node id : "
 		 << "size: " << npvp << ", PV name: ";
-	  for(int i = 0; i < npvp; i++) {
+	  for(G4int i = 0; i < npvp; i++) {
 	    G4cout << pPVModel->GetDrawnPVPath()[i].GetPhysicalVolume()->GetName()
 		   << " [param:"
@@ -1093,7 +1095,7 @@
       G4int nXY = kNestedVolumeDimension[0]*kNestedVolumeDimension[1];
 
-      for(int n0 = 0; n0 < kNestedVolumeDimension[0]; n0++) {
-	for(int n1 = 0; n1 < kNestedVolumeDimension[1]; n1++) {
-	  for(int n2 = 0; n2 < kNestedVolumeDimension[2]; n2++) {
+      for(G4int n0 = 0; n0 < kNestedVolumeDimension[0]; n0++) {
+	for(G4int n1 = 0; n1 < kNestedVolumeDimension[1]; n1++) {
+	  for(G4int n2 = 0; n2 < kNestedVolumeDimension[2]; n2++) {
 
 	    G4int repNo = n0 + n1*nX + n2*nXY;
@@ -1123,7 +1125,7 @@
       // mesh size
       if(!kbSetModalityVoxelSize) {
-	float spacing[3] = {2*phantomPara->GetVoxelHalfX(),
-			    2*phantomPara->GetVoxelHalfY(),
-			    2*phantomPara->GetVoxelHalfZ()};
+	G4float spacing[3] = {static_cast<G4float>(2*phantomPara->GetVoxelHalfX()),
+			      static_cast<G4float>(2*phantomPara->GetVoxelHalfY()),
+			      static_cast<G4float>(2*phantomPara->GetVoxelHalfZ())};
 	kgMocrenIO->setVoxelSpacing(spacing);
 	kVoxelDimension.set(spacing[0], spacing[1], spacing[2]);
@@ -1158,7 +1160,7 @@
 
     // get densities of the parameterized patient geometry
-    for(int n0 = 0; n0 < kNestedVolumeDimension[0]; n0++) {
-      for(int n1 = 0; n1 < kNestedVolumeDimension[1]; n1++) {
-	for(int n2 = 0; n2 < kNestedVolumeDimension[2]; n2++) {
+    for(G4int n0 = 0; n0 < kNestedVolumeDimension[0]; n0++) {
+      for(G4int n1 = 0; n1 < kNestedVolumeDimension[1]; n1++) {
+	for(G4int n2 = 0; n2 < kNestedVolumeDimension[2]; n2++) {
 
 	  G4double dens = 0.*(g/cm3);
@@ -1192,7 +1194,7 @@
     // mesh size
     if(!kbSetModalityVoxelSize) {
-      float spacing[3] = {boxSize.x()*2/nVoxels[0],
-			  boxSize.y()*2/nVoxels[1],
-			  boxSize.z()*2/nVoxels[2]};
+      G4float spacing[3] = {static_cast<G4float>(boxSize.x()*2/nVoxels[0]),
+			    static_cast<G4float>(boxSize.y()*2/nVoxels[1]),
+			    static_cast<G4float>(boxSize.z()*2/nVoxels[2])};
 
       kgMocrenIO->setVoxelSpacing(spacing);
@@ -1292,6 +1294,6 @@
     G4cout << "    " << tubes.GetName() << G4endl;
     G4Polyhedron * poly = tubes.CreatePolyhedron();
-    int nv = poly->GetNoVertices();
-    for(int i = 0; i < nv; i++) {
+    G4int nv = poly->GetNoVertices();
+    for(G4int i = 0; i < nv; i++) {
       G4cout << "    (" << poly->GetVertex(i).x() << ", "
 	     << poly->GetVertex(i).y() << ", "
@@ -1449,5 +1451,4 @@
   if(GFDEBUG_TRK) {
     std::cout << " ::AddCompound(const G4VTrajectory&) >>>>>>>>> " << std::endl;
-
     G4TrajectoriesModel * pTrModel = dynamic_cast<G4TrajectoriesModel*>(fpModel);
     if (!pTrModel) { 
@@ -1464,13 +1465,12 @@
       G4cout << "    momentum: " << trj->GetInitialMomentum() << G4endl;
       
-      int nPnt = trj->GetPointEntries();
+      G4int nPnt = trj->GetPointEntries();
       G4cout << "    point:    ";
-      for(int i = 0; i < nPnt; i++) {
+      for(G4int i = 0; i < nPnt; i++) {
 	G4cout << trj->GetPoint(i)->GetPosition() << ", ";
       }
       G4cout << G4endl;
-
-
-    }
+    }
+    G4cout << G4endl;
   }
 
@@ -1544,5 +1544,5 @@
       // Get attributes
       for(itr = attval->begin(); itr != attval->end(); itr++) {
-	for(int i = 0; i < nhitname; i++) {
+	for(G4int i = 0; i < nhitname; i++) {
 	  if(itr->GetName() == hitNames[i]) {
 
@@ -1601,5 +1601,5 @@
   
 
-  //for(int i = 0; i < nhitname; i++) {       // this selection trusts
+  //for(G4int i = 0; i < nhitname; i++) {       // this selection trusts
     //if(scorername == hitScorerNames[i]) {   // thea command /vis/scene/add/psHits hit_name.
 
@@ -1630,5 +1630,5 @@
     G4cout << "       >>>>> " << meshname << " : " << scorername  << G4endl;
 
-    for(int i = 0; i < nhitname; i++)
+    for(G4int i = 0; i < nhitname; i++)
       if(scorername == hitScorerNames[i]) 
 	G4cout << "       !!!! Hit scorer !!!! " << scorername << G4endl;
@@ -1702,5 +1702,5 @@
 
   // edge points of the detector
-  std::vector<float *> dedges;
+  std::vector<G4float *> dedges;
   G4Polyhedron * poly = solid.CreatePolyhedron();
   detector.polyhedron = poly;
@@ -1717,11 +1717,11 @@
     //uccolor[0] = uccolor[1] = uccolor[2] = 30; // dark grey
   }
-  for(int i = 0; i < 3; i++) detector.color[i] = uccolor[i];
+  for(G4int i = 0; i < 3; i++) detector.color[i] = uccolor[i];
   //
   kDetectors.push_back(detector);
 
   if(GFDEBUG_DET > 1) {
-    G4cout << "0     color:   (" << (int)uccolor[0] << ", "
-	   << (int)uccolor[1] << ", " << (int)uccolor[2] << ")"
+    G4cout << "0     color:   (" << (G4int)uccolor[0] << ", "
+	   << (G4int)uccolor[1] << ", " << (G4int)uccolor[2] << ")"
 	   << G4endl;
   }
@@ -1742,5 +1742,5 @@
 
     // edge points of the detector
-    std::vector<float *> dedges;
+    std::vector<G4float *> dedges;
     G4Polyhedron * poly = itr->polyhedron;
     poly->Transform(itr->transform3D);
@@ -1755,5 +1755,5 @@
     while(bnext) {
       if(!(poly->GetNextEdge(v1, v2, next))) bnext =false;
-      float * edge = new float[6];
+      G4float * edge = new G4float[6];
       edge[0] = v1.x()/mm;
       edge[1] = v1.y()/mm;
@@ -1772,5 +1772,5 @@
     //
     kgMocrenIO->addDetector(detname, dedges, uccolor);
-    for(int i = 0; i < nedges; i++) { // # of edges is 12.
+    for(G4int i = 0; i < nedges; i++) { // # of edges is 12.
       delete [] dedges[i];
     }
@@ -1778,6 +1778,6 @@
 
     if(GFDEBUG_DET > 1) {
-      G4cout << "    color:   (" << (int)uccolor[0] << ", "
-	     << (int)uccolor[1] << ", " << (int)uccolor[2] << ")"
+      G4cout << "    color:   (" << (G4int)uccolor[0] << ", "
+	     << (G4int)uccolor[1] << ", " << (G4int)uccolor[2] << ")"
 	     << G4endl;
     }
@@ -1789,5 +1789,5 @@
      kNestedVolumeDimension[1] == 0 ||
      kNestedVolumeDimension[2] == 0) {
-    for(int i = 0; i < 3; i++) _idx3d[i] = 0;
+    for(G4int i = 0; i < 3; i++) _idx3d[i] = 0;
     return;
   }
Index: /trunk/source/visualization/management/History
===================================================================
--- /trunk/source/visualization/management/History	(revision 1273)
+++ /trunk/source/visualization/management/History	(revision 1274)
@@ -1,3 +1,3 @@
-$Id: History,v 1.142 2010/05/11 12:17:40 allison Exp $
+$Id: History,v 1.143 2010/05/20 07:56:21 allison Exp $
 
 -------------------------------------------------------------------
@@ -26,4 +26,9 @@
 History file for visualization management sub-category
 ------------------------------------------------------
+
+20th May 2010  John Allison  (visman-V09-03-01)
+- G4VisCommandsCompound.cc: Restore previous viewer after /vis/drawTree.
+- G4VisManager.hh: Cosmetic.
+- G4VGraphicsSystem: Add Set methods.
 
 11th May 2010  John Allison  (visman-V09-03-00)
Index: /trunk/source/visualization/management/include/G4VGraphicsSystem.hh
===================================================================
--- /trunk/source/visualization/management/include/G4VGraphicsSystem.hh	(revision 1273)
+++ /trunk/source/visualization/management/include/G4VGraphicsSystem.hh	(revision 1274)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4VGraphicsSystem.hh,v 1.11 2006/06/29 21:28:04 gunter Exp $
+// $Id: G4VGraphicsSystem.hh,v 1.12 2010/05/20 07:55:47 allison Exp $
 // GEANT4 tag $Name:  $
 //
@@ -80,9 +80,13 @@
   const G4String& GetDescription   () const;
   Functionality   GetFunctionality () const;
+  void SetName          (const G4String&);
+  void SetNickName      (const G4String&);
+  void SetDescription   (const G4String&);
+  void SetFunctionality (Functionality);
 
 protected:
-  const G4String fName;
-  const G4String fNickname;
-  const G4String fDescription;
+  G4String fName;
+  G4String fNickname;
+  G4String fDescription;
   Functionality  fFunctionality;
 };
Index: /trunk/source/visualization/management/include/G4VGraphicsSystem.icc
===================================================================
--- /trunk/source/visualization/management/include/G4VGraphicsSystem.icc	(revision 1273)
+++ /trunk/source/visualization/management/include/G4VGraphicsSystem.icc	(revision 1274)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4VGraphicsSystem.icc,v 1.7 2006/06/29 21:28:06 gunter Exp $
+// $Id: G4VGraphicsSystem.icc,v 1.8 2010/05/20 07:55:47 allison Exp $
 // GEANT4 tag $Name:  $
 //
@@ -48,2 +48,18 @@
   return fFunctionality;
 }
+
+inline void G4VGraphicsSystem::SetName (const G4String& name) {
+  fName = name;
+}
+
+inline void G4VGraphicsSystem::SetNickName (const G4String& nickname) {
+  fNickname = nickname;
+}
+
+inline void G4VGraphicsSystem::SetDescription (const G4String& description) {
+  fDescription = description;
+}
+
+inline void G4VGraphicsSystem::SetFunctionality (Functionality f) {
+  fFunctionality = f;
+}
Index: /trunk/source/visualization/management/include/G4VisManager.hh
===================================================================
--- /trunk/source/visualization/management/include/G4VisManager.hh	(revision 1273)
+++ /trunk/source/visualization/management/include/G4VisManager.hh	(revision 1274)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4VisManager.hh,v 1.70 2009/02/25 18:28:00 lgarnier Exp $
+// $Id: G4VisManager.hh,v 1.71 2010/05/20 07:54:31 allison Exp $
 // GEANT4 tag $Name:  $
 //
@@ -366,8 +366,8 @@
 		      const G4VisExtent& = G4VisExtent::NullExtent);
   void SetUserActionExtent (const G4VisExtent&);
-  void              SetCurrentGraphicsSystem    (G4VGraphicsSystem* pSystem);
+  void              SetCurrentGraphicsSystem    (G4VGraphicsSystem*);
   void              SetCurrentScene             (G4Scene*);
-  void              SetCurrentSceneHandler      (G4VSceneHandler* pScene);
-  void              SetCurrentViewer            (G4VViewer* pView);
+  void              SetCurrentSceneHandler      (G4VSceneHandler*);
+  void              SetCurrentViewer            (G4VViewer*);
   G4SceneHandlerList& SetAvailableSceneHandlers ();  // Returns lvalue.
   G4SceneList&      SetSceneList                ();  // Returns lvalue.
Index: /trunk/source/visualization/management/src/G4VisCommandsCompound.cc
===================================================================
--- /trunk/source/visualization/management/src/G4VisCommandsCompound.cc	(revision 1273)
+++ /trunk/source/visualization/management/src/G4VisCommandsCompound.cc	(revision 1274)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4VisCommandsCompound.cc,v 1.39 2007/11/16 20:29:04 perl Exp $
+// $Id: G4VisCommandsCompound.cc,v 1.40 2010/05/20 07:54:01 allison Exp $
 // GEANT4 tag $Name:  $
 
@@ -66,4 +66,9 @@
   is >> pvname >> system;
 
+  G4VGraphicsSystem* keepSystem = fpVisManager->GetCurrentGraphicsSystem();
+  G4Scene* keepScene = fpVisManager->GetCurrentScene();
+  G4VSceneHandler* keepSceneHandler = fpVisManager->GetCurrentSceneHandler();
+  G4VViewer* keepViewer = fpVisManager->GetCurrentViewer();
+
   G4UImanager* UImanager = G4UImanager::GetUIpointer();
   G4int keepVerbose = UImanager->GetVerboseLevel();
@@ -77,4 +82,14 @@
   UImanager->ApplyCommand("/vis/viewer/flush");
   UImanager->SetVerboseLevel(keepVerbose);
+
+  if (keepViewer) {
+    if (fpVisManager->GetVerbosity() >= G4VisManager::warnings) {
+      G4cout << "Reverting to " << keepViewer->GetName() << G4endl;
+    }
+    fpVisManager->SetCurrentGraphicsSystem(keepSystem);
+    fpVisManager->SetCurrentScene(keepScene);
+    fpVisManager->SetCurrentSceneHandler(keepSceneHandler);
+    fpVisManager->SetCurrentViewer(keepViewer);
+  }
 }
 
Index: /trunk/source/visualization/test/History
===================================================================
--- /trunk/source/visualization/test/History	(revision 1273)
+++ /trunk/source/visualization/test/History	(revision 1274)
@@ -1,3 +1,3 @@
-$Id: History,v 1.121 2009/11/06 16:02:33 allison Exp $
+$Id: History,v 1.123 2010/05/11 12:06:08 allison Exp $
 
 History file for visualization/test subdirectory
@@ -5,4 +5,10 @@
 
 $Log: History,v $
+Revision 1.123  2010/05/11 12:06:08  allison
+vistest-V09-03-00
+
+Revision 1.122  2010/05/11 12:04:39  allison
+Added printEPS to test19.g4m, as suggested by Laurent.
+
 Revision 1.121  2009/11/06 16:02:33  allison
 vistest-V09-02-01
Index: /trunk/source/visualization/test/test19.g4m
===================================================================
--- /trunk/source/visualization/test/test19.g4m	(revision 1273)
+++ /trunk/source/visualization/test/test19.g4m	(revision 1274)
@@ -41,6 +41,6 @@
 #/vis/sceneHandler/create OGLSXm
 #/vis/sceneHandler/create OGLIX
-#/vis/sceneHandler/create OGLSX
-/vis/sceneHandler/create OGLSXm
+/vis/sceneHandler/create OGLSX
+#/vis/sceneHandler/create OGLSXm
 #/vis/sceneHandler/create VRML1
 #/vis/sceneHandler/create VRML1FILE
@@ -71,4 +71,8 @@
 # (all that happens is an extra refresh).
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-1
+/vis/ogl/printEPS
 #
 # Create another viewer.
@@ -80,4 +84,8 @@
 #
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-2
+/vis/ogl/printEPS
 #
 # Now hidden line removal.
@@ -90,4 +98,8 @@
 #
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-3
+/vis/ogl/printEPS
 #
 # Now hidden line *and* hidden surface removal.
@@ -100,4 +112,8 @@
 #
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-4
+/vis/ogl/printEPS
 #
 # Start a run to initialise/optimise geometry and draw user-drawn transients.
@@ -112,4 +128,8 @@
 /vis/scene/notifyHandlers
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-5
+/vis/ogl/printEPS
 #
 # Logical volume of Boolean solids...
@@ -122,4 +142,8 @@
 /vis/scene/notifyHandlers
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-6
+/vis/ogl/printEPS
 #
 /vis/scene/create
@@ -129,4 +153,8 @@
 /vis/viewer/set/viewpointThetaPhi 35 35
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-7
+/vis/ogl/printEPS
 #
 /vis/scene/create
@@ -136,4 +164,8 @@
 /vis/viewer/set/viewpointThetaPhi 35 35
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-8
+/vis/ogl/printEPS
 #
 # Send geantino through...
@@ -153,4 +185,8 @@
 /tracking/verbose 0
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-9
+/vis/ogl/printEPS
 #
 # Rotated tracker tube
@@ -172,4 +208,8 @@
 /run/beamOn
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-10
+/vis/ogl/printEPS
 #
 # G4Trap1
@@ -215,4 +255,8 @@
 /run/beamOn
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-11
+/vis/ogl/printEPS
 #
 # G4Trap2
@@ -241,4 +285,8 @@
 /run/beamOn
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-12
+/vis/ogl/printEPS
 #
 # Displaced solid.
@@ -252,4 +300,8 @@
 /run/beamOn
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-13
+/vis/ogl/printEPS
 #
 # Boolean solid.
@@ -313,4 +365,8 @@
 /run/beamOn
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-14
+/vis/ogl/printEPS
 #
 # To view replicas...
@@ -355,4 +411,8 @@
 /run/beamOn
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-15
+/vis/ogl/printEPS
 #...end
 #
@@ -360,4 +420,8 @@
 /vis/viewer/set/projection perspective 30
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-16
+/vis/ogl/printEPS
 #
 #/vis/sceneHandler/create OIX
@@ -367,4 +431,8 @@
 /vis/viewer/set/viewpointThetaPhi 30 30
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-17
+/vis/ogl/printEPS
 #
 # You can use /vis/rayTracer/... commands
@@ -378,6 +446,15 @@
 /vis/viewer/set/viewpointThetaPhi 45 45
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-18
+/vis/ogl/printEPS
 #
 # Odd!!?  JPEG image seems upside down for default view direction...
 /vis/viewer/create ! ! 200
 /vis/viewer/flush
+/vis/ogl/set/printMode vectored
+/vis/ogl/set/printSize 800 600
+/vis/ogl/set/printFilename output-test19-19
+/vis/ogl/printEPS
+exit
